JUCE: OutputStream Class Reference

JUCE

Public Member Functions | Protected Member Functions | List of all members
OutputStream Class Referenceabstract
juce_core » streams

The base class for streams that write data to some kind of destination. More...

`#include <juce_OutputStream.h>`

Inheritance diagram for OutputStream:

## Public Member Functions
virtual | ~OutputStream ()
| Destructor. More...
virtual void | flush ()=0
| If the stream is using a buffer, this will ensure it gets written out to the destination. More...
virtual bool | setPosition (int64 newPosition)=0
| Tries to move the stream's output position. More...
virtual int64 | getPosition ()=0
| Returns the stream's current position. More...
virtual bool | write (const void *dataToWrite, size_t numberOfBytes)=0
| Writes a block of data to the stream. More...
virtual bool | writeByte (char byte)
| Writes a single byte to the stream. More...
virtual bool | writeBool (bool boolValue)
| Writes a boolean to the stream as a single byte. More...
virtual bool | writeShort (short value)
| Writes a 16-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeShortBigEndian (short value)
| Writes a 16-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeInt (int value)
| Writes a 32-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeIntBigEndian (int value)
| Writes a 32-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeInt64 (int64 value)
| Writes a 64-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeInt64BigEndian (int64 value)
| Writes a 64-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeFloat (float value)
| Writes a 32-bit floating point value to the stream in a binary format. More...
virtual bool | writeFloatBigEndian (float value)
| Writes a 32-bit floating point value to the stream in a binary format. More...
virtual bool | writeDouble (double value)
| Writes a 64-bit floating point value to the stream in a binary format. More...
virtual bool | writeDoubleBigEndian (double value)
| Writes a 64-bit floating point value to the stream in a binary format. More...
virtual bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat)
| Writes a byte to the output stream a given number of times. More...
virtual bool | writeCompressedInt (int value)
| Writes a condensed binary encoding of a 32-bit integer. More...
virtual bool | writeString (const String &text)
| Stores a string in the stream in a binary format. More...
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
| Writes a string of text to the stream. More...
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
| Reads data from an input stream and writes it to this stream. More...
void | setNewLineString (const String &newLineString)
| Sets the string to write to the stream when a new line is written. More...
const String & | getNewLineString () const noexcept
| Returns the current new-line string that was set by setNewLineString(). More...

## Protected Member Functions
| OutputStream ()

## Detailed Description

The base class for streams that write data to some kind of destination.

Input and output streams are used throughout the library - subclasses can override some or all of the virtual functions to implement their behaviour.

See also
  InputStream, MemoryOutputStream, FileOutputStream

## Constructor & Destructor Documentation

## ◆ OutputStream()

OutputStream::OutputStream | ( |  | ) |
| protected

## ◆ ~OutputStream()

virtual OutputStream::~OutputStream | ( |  | ) |
| virtual

Destructor.

Some subclasses might want to do things like call flush() during their destructors.

## Member Function Documentation

## ◆ flush()

virtual void OutputStream::flush | ( |  | ) |
| pure virtual

If the stream is using a buffer, this will ensure it gets written out to the destination.

Implemented in ARAOutputStream, FileOutputStream, MemoryOutputStream, and GZIPCompressorOutputStream.

## ◆ setPosition()

virtual bool OutputStream::setPosition | ( | int64 | newPosition | ) |
| pure virtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implemented in ARAOutputStream, FileOutputStream, MemoryOutputStream, and GZIPCompressorOutputStream.

## ◆ getPosition()

virtual int64 OutputStream::getPosition | ( |  | ) |
| pure virtual

Returns the stream's current position.

See also
  setPosition

Implemented in ARAOutputStream, FileOutputStream, MemoryOutputStream, and GZIPCompressorOutputStream.

## ◆ write()

virtual bool OutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes
| ) |  |
| pure virtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implemented in ARAOutputStream, FileOutputStream, MemoryOutputStream, and GZIPCompressorOutputStream.

## ◆ writeByte()

virtual bool OutputStream::writeByte | ( | char | byte | ) |
| virtual

Writes a single byte to the stream.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readByte

## ◆ writeBool()

virtual bool OutputStream::writeBool | ( | bool | boolValue | ) |
| virtual

Writes a boolean to the stream as a single byte.

This is encoded as a binary byte (not as text) with a value of 1 or 0.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readBool

## ◆ writeShort()

virtual bool OutputStream::writeShort | ( | short | value | ) |
| virtual

Writes a 16-bit integer to the stream in a little-endian byte order.

This will write two bytes to the stream: (value & 0xff), then (value >> 8).

Returns
  false if the write operation fails for some reason

See also
  InputStream::readShort

## ◆ writeShortBigEndian()

virtual bool OutputStream::writeShortBigEndian | ( | short | value | ) |
| virtual

Writes a 16-bit integer to the stream in a big-endian byte order.

This will write two bytes to the stream: (value >> 8), then (value & 0xff).

Returns
  false if the write operation fails for some reason

See also
  InputStream::readShortBigEndian

## ◆ writeInt()

virtual bool OutputStream::writeInt | ( | int | value | ) |
| virtual

Writes a 32-bit integer to the stream in a little-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readInt

## ◆ writeIntBigEndian()

virtual bool OutputStream::writeIntBigEndian | ( | int | value | ) |
| virtual

Writes a 32-bit integer to the stream in a big-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readIntBigEndian

## ◆ writeInt64()

virtual bool OutputStream::writeInt64 | ( | int64 | value | ) |
| virtual

Writes a 64-bit integer to the stream in a little-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readInt64

## ◆ writeInt64BigEndian()

virtual bool OutputStream::writeInt64BigEndian | ( | int64 | value | ) |
| virtual

Writes a 64-bit integer to the stream in a big-endian byte order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readInt64BigEndian

## ◆ writeFloat()

virtual bool OutputStream::writeFloat | ( | float | value | ) |
| virtual

Writes a 32-bit floating point value to the stream in a binary format.

The binary 32-bit encoding of the float is written as a little-endian int.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readFloat

## ◆ writeFloatBigEndian()

virtual bool OutputStream::writeFloatBigEndian | ( | float | value | ) |
| virtual

Writes a 32-bit floating point value to the stream in a binary format.

The binary 32-bit encoding of the float is written as a big-endian int.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readFloatBigEndian

## ◆ writeDouble()

virtual bool OutputStream::writeDouble | ( | double | value | ) |
| virtual

Writes a 64-bit floating point value to the stream in a binary format.

The eight raw bytes of the double value are written out as a little-endian 64-bit int.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readDouble

## ◆ writeDoubleBigEndian()

virtual bool OutputStream::writeDoubleBigEndian | ( | double | value | ) |
| virtual

Writes a 64-bit floating point value to the stream in a binary format.

The eight raw bytes of the double value are written out as a big-endian 64-bit int.

See also
  InputStream::readDoubleBigEndian

Returns
  false if the write operation fails for some reason

## ◆ writeRepeatedByte()

virtual bool OutputStream::writeRepeatedByte | ( | uint8 | byte,
|  | size_t | numTimesToRepeat
| ) |  |
| virtual

Writes a byte to the output stream a given number of times.

Returns
  false if the write operation fails for some reason

Reimplemented in FileOutputStream, and MemoryOutputStream.

## ◆ writeCompressedInt()

virtual bool OutputStream::writeCompressedInt | ( | int | value | ) |
| virtual

Writes a condensed binary encoding of a 32-bit integer.

If you're storing a lot of integers which are unlikely to have very large values, this can save a lot of space, because values under 0xff will only take up 2 bytes, under 0xffff only 3 bytes, etc.

The format used is: number of significant bytes + up to 4 bytes in little-endian order.

Returns
  false if the write operation fails for some reason

See also
  InputStream::readCompressedInt

## ◆ writeString()

virtual bool OutputStream::writeString | ( | const String & | text | ) |
| virtual

Stores a string in the stream in a binary format.

This isn't the method to use if you're trying to append text to the end of a text-file! It's intended for storing a string so that it can be retrieved later by InputStream::readString().

It writes the string to the stream as UTF8, including the null termination character.

For appending text to a file, instead use writeText, or operator<<

Returns
  false if the write operation fails for some reason

See also
  InputStream::readString, writeText, operator<<

## ◆ writeText()

virtual bool OutputStream::writeText | ( | const String & | text,
|  | bool | asUTF16,
|  | bool | writeUTF16ByteOrderMark,
|  | const char * | lineEndings
| ) |  |
| virtual

Writes a string of text to the stream.

It can either write the text as UTF-8 or UTF-16, and can also add the UTF-16 byte-order-mark bytes (0xff, 0xfe) to indicate the endianness (these should only be used at the start of a file).

If lineEndings is nullptr, then line endings in the text won't be modified. If you pass "\\n" or "\\r\\n" then this function will replace any existing line feeds.

Returns
  false if the write operation fails for some reason

## ◆ writeFromInputStream()

virtual int64 OutputStream::writeFromInputStream | ( | InputStream & | source,
|  | int64 | maxNumBytesToWrite
| ) |  |
| virtual

Reads data from an input stream and writes it to this stream.

Parameters

  source | the stream to read from
  maxNumBytesToWrite | the number of bytes to read from the stream (if this is less than zero, it will keep reading until the input is exhausted)

Returns
  the number of bytes written

Reimplemented in MemoryOutputStream.

## ◆ setNewLineString()

void OutputStream::setNewLineString | ( | const String & | newLineString | ) |

Sets the string to write to the stream when a new line is written.

By default this will be set the value of NewLine::getDefault().

## ◆ getNewLineString()

const String & OutputStream::getNewLineString | ( |  | ) | const
| noexcept

Returns the current new-line string that was set by setNewLineString().

The documentation for this class was generated from the following file:

- juce_OutputStream.h